#include <iostream>
#include <locale.h>
#include <math.h>
#include <fstream>
#include<iomanip>
#include <cmath>

using namespace std;

class fly ///   
{

private: ///    
    double Vo, Agrad, Brad, time, step, amountdouble; ///Vo-  ; Agrad-,    ,  ;
                                                      ///Brad-,    ,  ; time-  ; step-;
                                                      ///amountdouble-  ( double)

public: ///   
    int amount; ///amoun-  ( int)

fly (double _step, double _Agrad, double _Vo):step(_step),Agrad(_Agrad),Vo(_Vo) ///     
{

    double g=9.8; ///     g(  )
    Brad=3.14159*Agrad/180.0; ///      

    time=2*Vo*sin(Brad)/g; ///   
    amountdouble=(round(time/step)+1); ///     
    amount=static_cast<int>(amountdouble); ///    double   int

}
void zapis (char Zapis[]) ///  
{
    double g=9.8, m=1, n=0.05; ///     g (  ), m ( ), n( )
    double Xb, Yb; ///         Xb(   ), Yb(   )
    double V=Vo, Vxv=Vo*cos(Brad), Vyv=Vo*sin(Brad), Xo=0, Yo=0, Xv=0, Yv=0, Y_1=Yo-Vo*sin(Brad)*step, X_1=Xo-Vo*cos(Brad)*step, Y=0, X=0;
           ///     I V (   ), Vxv (   ),
           ///Vyv (   ), Xo (     ), Yo (     ),
           ///Xv (    ), Yv (    ), Y_1 (   (n-1)    ),
           ///X_1 (   (n-1)    ), Y (   n-    ),
           ///X (   n-    );
    double Vxv2=Vo*cos(Brad), Vyv2=Vo*sin(Brad), Xo2=0, Yo2=0, Xv2=0, Yv2=0, Y_12=Yo2-Vo*sin(Brad)*step, X_12=Xo-Vo*cos(Brad)*step, Y2=0, X2=0;
           ///     II V (   ), Vxv (   ),
           ///Vyv (   ), Xo (     ), Yo (     ),
           ///Xv (    ), Yv (    ), Y_1 (   (n-1)    ),
           ///X_1 (   (n-1)    ), Y (   n-    ),
           ///X (   n-    );
    double Yt=0, Xt=0, Yot=0, Xot=0, Voxt=Vo*cos(Brad), Voyt=Vo*sin(Brad);

    ofstream outfile("Zapis.txt"); ///     "Zapis.txt"
    outfile<<setw(20)<<"Xb"<<setw(20)<<"Yb"<<setw(20)<<"Xt"<<setw(20)<<"Yt"<<setw(20)<<"Xv"<<setw(20)<<"Yv"<<setw(20)<<"Xv2"<<setw(20)<<"Yv2"<<" \n"; ///    
                                                                                  ///X (      ),
                                                                                  ///Y (      ),
                                                                                  ///Xv (         ),
                                                                                  ///Yv (         )
                                                                                  ///setw()  

    for (int l=0; Yb>=0; ++l) ///   0       
    {
        outfile<<setw(20)<<Xb<<setw(20)<<Yb<<setw(20)<<Xt<<setw(20)<<Yt<<setw(20)<<Xv<<setw(20)<<Yv<<setw(20)<<Xv2<<setw(20)<<Yv2<<" \n";
            ///     Xv, Yv;

        ///  
        Xb=Vo*cos(Brad)*l*step;
        Yb=Vo*sin(Brad)*l*step-(9.8*l*step*l*step*0.5);

        /// 
        Xt=Xot+(m/n)*Voxt*(1.0 - exp((-n*l*step)/m));
        Yt=Yot+(m/n)*(Voyt+g*(m/n))*(1.0 - exp((-n*l*step)/m))-g*l*step*(m/n);

        ///  I
        Xv=2*X-X_1-(n/m)*V*Vxv*step*step; ///      t   
        Yv=2*Y-Y_1-(g+(n/m)*V*Vyv)*step*step; ///      t   
        Vxv=(Xv-X_1)/(2.0*step); ///         t   
        Vyv=(Yv-Y_1)/(2.0*step); ///         t   
        V=sqrt(Vxv*Vxv+Vyv*Vyv); ///    
        X_1=X; ///     (n-1)      n- 
        X=Xv;  ///     n-    
        Y_1=Y; ///     (n-1)      n- 
        Y=Yv;  ///     n-    

        ///  II
        Xv2=2*X2-X_12-(n/m)*Vxv2*step*step; ///      t   
        Yv2=2*Y2-Y_12-(g+(n/m)*Vyv2)*step*step; ///      t   
        Vxv2=(Xv2-X_12)/(2.0*step); ///         t   
        Vyv2=(Yv2-Y_12)/(2.0*step); ///         t   
        X_12=X2; ///     (n-1)      n- 
        X2=Xv2;  ///     n-    
        Y_12=Y2; ///     (n-1)      n- 
        Y2=Yv2;  ///     n-    

    }

    outfile.close();

}

};

int main()
{

    setlocale(LC_ALL,"RUS"); ///,  ++   

    double Vo, Agrad, Brad, time, step; ///   Vo (  ), Agrad (,    ,  );
                                        ///Brad (,    ,  ); time (  ); step ()
    cout<<"     /: Vo="; ///         
    cin>>Vo; ///    
    cout<<'\n'<<"   ,     (     0  90): a=";
                                                        ///       ,    ,  
    cin>>Agrad; ///  ,    
    cout<<'\n'<<"  (    ): ="; ///       
    cin>>step; ///  

    fly X(step,Agrad,Vo); /// ,   ,   step,Agrad,Vo
    X.zapis(".txt"); ///    

    return 0; /// 

}
